/* RAW socket utility routine:
 * 
 * Write out a TCP header.
 * shadows@whitefang.com
 * Thamer Al-Herbish
 */

#include <stdlib.h>
#include <stdio.h>

#include <sys/types.h>
#include <sys/socket.h>

#include <netinet/in.h>
#include <arpa/inet.h>

#include <netinet/in_systm.h>

#if defined(LINUX)
#include <linux/tcp.h>
#else
#include <netinet/tcp.h>
#endif

#include <unistd.h>
#include <string.h>

#if defined(X2_OFF)         /* SCO */
#define TH_OFFSET 0x50         /* TCP header offset */
#else
#define TH_OFFSET 5
#endif

int tcp_chkx(char *packet, unsigned short *sport, unsigned short *dport,
	     unsigned long *seq, unsigned long *ack,
	     char *b_fin, char *b_ack, char *b_rst, char *b_syn)
{
  int result = 0;
  struct tcphdr *tcp;
  
  tcp = (struct tcphdr *)packet;

  if (sport != NULL) {
    if (*sport && tcp->source != htons(*sport)) {
      result++;
    }
    *sport = ntohs(tcp->source);
  }
  if (dport != NULL) {
    if (*dport && tcp->dest != htons(*dport)) {
      result++;
    }
    *dport = ntohs(tcp->dest);
  }
  if (seq != NULL) {
    if (*seq && tcp->seq != htonl(*seq)) {
      result++;
    }
    *seq = ntohl(tcp->seq);
  }
  if (ack != NULL) {
    if (*ack && tcp->ack_seq != htonl(*ack)) {
      result++;
    }
    *ack = ntohl(tcp->ack_seq);
  }
  if (b_fin != NULL) *b_fin = tcp->fin;
  if (b_ack != NULL) *b_ack = tcp->ack;
  if (b_rst != NULL) *b_rst = tcp->rst;
  if (b_syn != NULL) *b_syn = tcp->syn;

  return(result);
}

int tcp_chk(char *packet,char *ptn, unsigned short sport,
	    unsigned short dport, unsigned long seq,
	    unsigned long ack)
{
  return(tcp_chkx(packet, &sport, &dport, &seq, &ack, NULL, NULL, NULL, NULL));
}

int tcp_dataoffset(char *packet)
{
  struct tcphdr *tcp;

  tcp = (struct tcphdr *)packet;
  return(tcp->doff);
}

int tcp_option(char *packet, char *buf, int len)
{
  char *option;

  option = packet + sizeof(struct tcphdr);
  memcpy(buf, option, len);

  return(len);
}
